import getUri from '../lib/ids';
import { put } from './lib';
import { putNewTrk } from './trk';

const emptyTrkseg: Trkseg = {
  trkpt: undefined,
  extensions: undefined,
};

export const putNewTrkseg = async (id?: IdTrk | IdGpx | IdTrkseg) => {
  let finalId = { ...id };
  if (!('trkseg' in finalId)) {
    const trkId = await putNewTrk(id);
    finalId = { ...trkId, trkseg: '00000' };
  }
  const uri = getUri('trkseg', finalId);
  await put(
    uri,
    'trkseg',
    (trkseg) => {
      return trkseg;
    },
    emptyTrkseg
  );
  return finalId as IdTrkseg;
};
